package jactor;
import java.io.*;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;
/**************************************************

jactor :  v1.2 - Mars 2007
un petit langage d'acteur pour apprendre
la programmation par acteur

	il est trs simple et pas du tout performant
	mais il a le mrite de montrer
	comment on programme en acteurs..
	Ensuite on prfrera des langages plus complets comme MadKit par exemple

(C) J.Ferber  - 1999-2007
    with parts written  by Olivier Gutknecht

***************************************************/

/**************************************************

	Actor: la classe abstraite dont tous les 

	(C) J.Ferber  - 1999-2007
    

	un petit systme d'acteur crit en Java
	il est trs simple et pas du tout performant
	mais bon, il a le mrite de montrer
	comment on programme en acteurs

***************************************************/

public abstract class Actor implements Runnable {
	
	public static boolean debug=true;
	public static void setDebug(boolean b){
		debug = b;
	}
	public static boolean isDebug(){return(debug);}

    public boolean living=true;

    public void kill(){
        living=false;
    }

  // la structure des acteurs proprement dits

  // la gestion des messages
  List messages=new LinkedList();

  public Actor(){
          thread = new Thread(this);
          thread.start();
  }

  /** Is there any message left to be read ? */
  public boolean isMessageBoxEmpty(){	return messages.isEmpty();}

  /** Get the number of messages in the message box */
  public int getMessageBoxSize()
  {
      return messages.size();
  }

  /** Gets the first message in the queue.
      @returns the first item in the message queue, or null if there is no message available
  */
  public Message nextMessage()
  {
      if (! isMessageBoxEmpty())
              return (Message) messages.remove(0);
          return null;
  }

  public void sendMessage(Actor o, Message m){
  		m.sender(this);
  		o.receiveMessage(m);
  }

  public void handleMessage(Message m){
  		defaultHandleMessage(m);
  }
  
  protected void defaultHandleMessage(Message m){
	/*  Method meth=null;
	  try {
		Class c = this.getClass();
		if (m.getArgument() == null){
			meth = c.getMethod(m.getRequest(),null);
			Object r = meth.invoke(this,args);
		} else {
			Object[] args = (Object[]) m.getArgument();
			Class[] types=new Class[args.length];
			for (int i=0;i<types.length;i++){
				types[i] = args[i].getClass();
			}
			meth = c.getMethod(m.getRequest(),types);
			Object r = meth.invoke(this,args);
		} 
	} catch (SecurityException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (NoSuchMethodException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}catch (IllegalArgumentException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (IllegalAccessException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (InvocationTargetException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
  		*/
  }
  

  public void receiveMessage(Message m){
      messages.add(m);
      if (isDebug()) 
    	  System.out.println(":: Message : " + m + " a " + this);
      synchronized (messages){
              messages.notifyAll();
      }
  }

  transient Thread thread;

  final public void pause(int t)
      {
          try {Thread.sleep(t);}
          catch (InterruptedException e) {}
  }

  final Message waitNextMessage() {
      try{
          synchronized(messages){
              while(messages.isEmpty()) {
                  messages.wait();
              }
          }
          return nextMessage();
      }
      catch (InterruptedException e){
          return  null;
      }
  }

  final public void run(){
      try{
          while(living){
              Message m = waitNextMessage();
              this.handleMessage(m);
          }
      }
      catch (RuntimeException r){
          System.err.println("Runtime Actor Exception : " + r.toString());
          r.getMessage();
          r.printStackTrace();
          System.err.println(this+" Agent killed.");
      }
      catch (Exception e){
          System.err.println("### UNDEFINED EXCEPTION ! : " + e.toString());
          e.printStackTrace();
      }
  }
}
