package jactor;
import java.io.*;

/**
	Implementation de l'algo rcursif de Fibonacci en parallele
	Cette ralisation montre l'intret de la JoinList
	pour synchroniser deux calculs
	(C) J. Ferber - Janvier 2000
	
	rappel de fibo:
	fibo(int n)=
		if (n <= 2)
			return 1
		else
			return fibo(n-1) + fibo(n-2)
***/

public class Fibo extends Actor {
    int val;
    
    public void handleMessage(Message m){
    	if (m.getRequest().equals("call")){
    		val = (int)(Integer)m.getArgument();
    		Actor cont=m.getCont();
        	if (val <= 2){
    			sendMessage(cont,new Message("reply",new Integer(1)));
        	} else {
        		// on construit le reseau de calcul
        		Actor adder = new Adder(cont);
        		Actor ja = new Join2(adder);
            	sendMessage(this, new Message("call",new Integer(val-1),ja));
            	sendMessage(this, new Message("call",new Integer(val-2),ja));
        	}
    	}
    }
    
    public Fibo(int r, Actor c){
	    sendMessage(this,new Message("call",new Integer(r),c));
	}
    
}
