/**************************************************

	JoinListActor

	Une classe abstraite dcrivant un
	acteur qui recupere une liste de reponses et execute ensuite un script.

	(C) J.Ferber - Novembre 1999

***************************************************/

package jactor;
import java.io.*;


/**
 * @author J.Ferber
 *
 * Une classe d'acteur qui prend gre un "rendez vous" entre une liste d'acteurs
 * 
 */
public abstract class JoinListActor extends Actor {

	int cpt=0;

	Actor cont;
	Object[] parameter;

	public void setCont(Actor c){
		cont = c;
	}

	void script() {}

	public void init(int n, Actor c){
		cont = c;
		init(n);
	}
	public void init(int n){
		cpt = n;
		parameter = new Object[n];
	}

	public void handleMessage(Message m){
			String request = m.getRequest();
			if (request == "reply"){
				parameter[cpt-1] = m.getArgument();
				cpt--;
				if (cpt == 0){
					script();
				}
			}
    }
}

